<?php
$title = "Edit Election";
headers(array('title'=>$title,'menu'=>1,
	      'head_extras'=>'<script language="Javascript" src="lib/popupcalendar/calendar.js"></script>',
	      )
	);

if(!has_permission(get_member_id($_SESSION['user']),'election admin')) {
  ?>
  <div class="error">
  <p>You do not have permission to do this.</p>
  </div>
<?php
  exit();
}

if($_GET['id'] && !$_POST) {
  global $dbh;
  // we have an id we're going to edit, get the data from the database.
  // We get into $_POST as then the forms infrastructure takes care
  // of a bunch of stuff for us
  $row = sql_select('election','id='.$dbh->quote($_GET['id']));
  $_POST['name'] = $row->name;
  $_POST['desc'] = $row->description;
  $_POST['num_req_nominations'] = $row->num_req_nominations;
  $_POST['start_advertising_date'] = date("d/m/Y",
					  strtotime($row->start_advertising));
  $_POST['start_advertising_time'] = date("H:i",
					  strtotime($row->start_advertising));
  $_POST['start_nominations_date'] = date("d/m/Y",
					  strtotime($row->nominations_start));
  $_POST['start_nominations_time'] = date("H:i",
					  strtotime($row->nominations_start));
  $_POST['close_nominations_date'] = date("d/m/Y",
					  strtotime($row->nominations_close));
  $_POST['close_nominations_time'] = date("H:i",
					  strtotime($row->nominations_close));
  $_POST['advertise_candidates_date'] = date("d/m/Y",
					strtotime($row->advertise_candidates));
  $_POST['advertise_candidates_time'] = date("H:i",
					strtotime($row->advertise_candidates));
  $_POST['live_results'] = $row->live_results;
  $_POST['start_voting_date'] = date("d/m/Y",strtotime($row->start_voting));
  $_POST['start_voting_time'] = date("H:i",strtotime($row->start_voting));
  $_POST['close_voting_date'] = date("d/m/Y",strtotime($row->close_voting));
  $_POST['close_voting_time'] = date("H:i",strtotime($row->close_voting));
  $_POST['show_results_date'] = date("d/m/Y",strtotime($row->show_results));
  $_POST['show_results_time'] = date("H:i",strtotime($row->show_results));
  $sql = "select * from election_position where election_id=".
    $dbh->quote($_GET['id']);
  $result = $dbh->query($sql);
  for($i=0;$row = $result->fetchrow(DB_FETCHMODE_OBJECT);$i++) {
    eval("\$_POST['position".($i?$i:'0')."_name'] = '".$row->name."';");
    eval("\$_POST['position".($i?$i:'0')."_num'] = '".$row->num."';");
    eval("\$_POST['position".($i?$i:'0')."_desc'] = '".$row->description."';");
  }
  $_POST['nrpositions']=$i;
}

function datetime_formitem($title,$name,$desc) {
  return array('type'=>'fieldset',
	       'legend'=>$title,
	       'fields'=>
	       array($name.'desc'=>array('type'=>'html',
				    'html'=>$desc),
		     $name.'_date'=>
		     array('label'=>'Date',
			   'required'=>1,
			   'type'=>'date',
			   'default'=>date("d/m/Y"),
			   'valid'=>array(
					  'preg_match("/\w+/", $val)'
					  =>'Must have a date'
					  ),
			   ),
		     $name.'_time'=>
		     array('label'=>'Time',
			   'required'=>1,
			   'type'=>'text',
			   'default'=>date("H:m"),
			   'valid'=>array(
					  '$a = split(":",$val); return $a[0]>=0 && $a[0]<24 && $a[1]>=0 && $a[1]<60;'=>'Not a valid time'),
			   ),
		     ),
	       );
  
}

$electionform =
array('general'=>array('type'=>'fieldset',
		       'legend'=>'Election Information',
      'fields'=>array(
	     'name'=>array('type'=>'text',
			   'label'=>'Name',
			   'maxlength'=>50,
			   'required'=>1,
			   'valid'=>array(
					  'preg_match("/\w+/", $val)'
					  =>'Must enter a name for the election'
					  ),
			   ),
	     'for'=>array('label'   =>'For',
			  'type'    =>'select',
			  'options' =>array('This Organisation','Any Organisation'),
			  ),
	     'num_req_nominations'=>array(
					  'type'=>'text',
					  'label'=>'Number of requried nominations',
					  'maxlength'=>5,
					  'default'=>2,
					  'valid'=>array(
							 '$val >= 0'=>
							 'Must be a number >= 0'
							 ),
					  ),
	     'desc'=>array('type'=>'textarea',
			   'label'=>'Description',
			   'title'=>'Description of this election',
			   'rows'=>5,
			   'cols'=>40,
			   ),
	     'start_advertising'=>datetime_formitem("Start Advertising",
						    'start_advertising',
						    '<p>Date and time from which people can see that the election exists.</p>'),
	     'start_nominations'=>datetime_formitem("Start Nominations",
						    'start_nominations',
						    '<p>Date and time where people can nominate others for positions.</p>'),
	     'close_nominations'=>datetime_formitem("End Nominations",
						    'close_nominations',
						    '<p>When the nomination period closes.</p>'),
	     'advertise_candidates'=>datetime_formitem("Advertise Candidates",
						       'advertise_candidates',
						       '<p>When a list of candidates (accepted nominees) are available for viewing.</p>'),
	     'start_voting'=>datetime_formitem("Start Voting",'start_voting',
					       '<p>When voting starts</p>'),
	     'close_voting'=>datetime_formitem("Close Voting",'close_voting',
					       '<p>When voting closes</p>'),
	     'show_results'=>datetime_formitem("Show Results",'show_results',
					       '<p>When the results are visible.</p>'),
	     'live_results'=>array('type'=>'checkbox',
				   'label'=>'Show Live Results'),
	     )
		       )
      );

      // Add another position if asked
if($_POST['more_positions']=='Add Position')
  $_POST['nrpositions']++;

  // never allow < 0 positions
if($_POST['nrpositions']<0)
  $_POST['nrpositions']=0;

  // Sane default
if(!isset($_POST['nrpositions']))
  $_POST['nrpositions']=1;

  // Check if we're removing any
foreach(array_keys($_POST) as $item) {
  if(preg_match('/^position(\d+)_delete$/',$item,$matches)) {
    // if so, move all the data down.
    // We manipulate $_POST here as there is no use duplicating data.
    for($i=$match[0];$i<$_POST['nrpositions'];$i++) {
      eval("\$_POST['position".($i?$i:'0')."_name'] = \$_POST['position".($i+1)."_name'];");
      eval("\$_POST['position".($i?$i:'0')."_desc'] = \$_POST['position".($i+1)."_desc'];");
      eval("\$_POST['position".($i?$i:'0')."_num'] = \$_POST['position".($i+1)."_num'];");
    }
    $_POST['nrpositions']--;
  }
}

$electionform+= array('nrpositions'=>array('type'=>'hidden',
					   'default'=>1,),
		      'more_positions'=>array('type'=>'button',
					      'label'=>'Add Position'),
		      );

for($i=0;$i<$_POST['nrpositions'];$i++) {
  $electionform+= array('position'.$i=>array('type'=>'fieldset',
					     'legend'=>'Position '.($i+1),
					     'fields'=>
					     array(
		        'position'.$i.'_name'=>array('type'=>'text',
						     'required'=>1,
						     'maxlength'=>50,
						     'label'=>'Name',
						     'valid'=>array(
					  'preg_match("/\w+/", $val)'
					  =>'Must enter a name for the position'
					  ),
						     ),
			'position'.$i.'_num'=>array('type'=>'text',
						    'label'=>'Number',
						    'maxlength'=>5,
						    'default'=>1,
						    'valid'=>array(
					  '$val>0'=>'Must be a number &gt; 0'
					  ),
						    ),
		        'position'.$i.'_desc'=>array('type'=>'textarea',
						     'label'=>'Description',
						     'cols'=>40,
						     'rows'=>5,
						     'title'=>'Position Description'
						     ),
			'position'.$i.'_delete'=>array('type'=>'button',
						       'label'=>'Remove'),
			),
					     ),
			);
}

/* pass $_POST as we have manipulated it previously (i.e. it is now
 * different to $HTTP_POST_VARS due to the whole PHP references crap.
 */
$errors = validate($electionform, $_POST);

if(!$errors && isset($_POST['edit_election'])) {
  // We have a valid form, and have been asked to apply it
  global $dbh,$config;
  $err = $dbh->autoCommit(false);
  if($err!=DB_OK) {
    my_syslog(LOG_ERR,"Error while disabling autoCommit: $err,".
	      var_export($err));
    echo '<p class="error">Internal database error, please report this';
    echo ' to the webmaster</p>.';
    exit(0);
  }
  $dbh->query("begin");
  sql_insert('election',
	     array('name'=>$_POST['name'],
		   'org_id'=>($_POST['for']=='This Organisation')?$config['org_id'] : 'NULL',
		   'num_req_nominations'=>$_POST['num_req_nominations'],
		   'description'=>$_POST['desc'],
		   'start_advertising'=>$_POST['start_advertising_date'].' '.$_POST['start_advertising_time'],
		   'nominations_start'=>$_POST['start_nominations_date'].' '.$_POST['start_nominations_time'],
		   'nominations_close'=>$_POST['close_nominations_date'].' '.$_POST['close_nominations_time'],
		   'advertise_candidates'=>$_POST['advertise_candidates_date'].' '.$_POST['advertise_candidates_time'],
		   'live_results'=>$_POST['live_results'],
		   'start_voting'=>$_POST['start_voting_date'].' '.$_POST['start_voting_time'],
		   'close_voting'=>$_POST['close_voting_date'].' '.$_POST['close_voting_time'],
		   'show_results'=>$_POST['show_results_date'].' '.$_POST['show_results_time'],
		   )
	     );
  $electionq = $dbh->query("select LAST_INSERT_ID() as id");
  $election = $electionq->fetchrow(DB_FETCHMODE_OBJECT);
  for($i=0;$i<$_POST['nrpositions'];$i++) {
    sql_insert('election_position',
	       array('election_id'=>$election->id,
		     'name'=>eval("return \$_POST['position".($i?$i:'0')."_name'];"),
		     'num'=>eval("return \$_POST['position".($i?$i:'0')."_num'];"),
		     'description'=>eval("return \$_POST['position".($i?$i:'0')."_desc'];"),
		     )
	       );
  }
  if($dbh->commit()) {
    echo '<p>Election has been edited. You can ';
    echo '<a href="'.$PHP_SELF.'?page=edit-election&id='.$election->id.'">continue to edit';
    echo '</a> it.</p>';
  } else {
    echo '<p class="error">There was an error editing the election.</p>';
  }
} else {
  echo '<div class="stdform">';
  print $errors;
  output_form($electionform,"edit_election","Apply","post","");
  echo '</div>';
}
?>

