<?php
$title = "View Election";
headers(array('title'=>$title,'menu'=>1,
	      'head_extras'=>'<script language="Javascript" src="lib/popupcalendar/calendar.js"></script>'.
	      '<script language="Javascript" src="lib/sorttable.js"></script>',
	      )
	);

if(has_permission(get_member_id($_SESSION['user']),'election admin'))
  $can_edit = 1;

if(!$_GET['id']) {
  echo '<p class="error">No Election ID specified.</p>';
  exit(0);
}

require_once('backend/election.inc');

$election = get_election($_GET['id']);

?>

<h2><?=htmlise($election['name'])?></h2>
<?php
if($can_edit)
     echo '<p><a href="?page=edit-election&id='.$_GET['id'].'">edit election</a></p>';
?>
<p><?=htmlise($election['desc'])?></p>

<h2>Times</h2>
<p>The current time is: <?= date("d/m/Y H:m",time());?>. All dates and times are server time, not your local time.</p>
<table class="sortable" id="election_times">
<thead>
<tr>
<th>Item</th>
<th>Start</th>
<th>End</th>
<th>Status</th>
</tr>
</thead>
<tbody>
<tr>
  <td>Visible</td>
  <td><?=htmlise($election['start_advertising'])?></td>
  <td>&nbsp;</td>
  <td><?=htmlise($election['advertise'])?></td>
</tr>
<tr>
  <td><a href="#nominations">Nominations</a></td>
  <td><?=htmlise($election['start_nominations'])?></td>
  <td><?=htmlise($election['close_nominations'])?></td>
  <td><?=htmlise($election['nominations-status'])?></td>
</tr>
<tr>
  <td><a href="#candidates">Advertise Candidates</a></td>
  <td><?=htmlise($election['advertise_candidates'])?></td>
  <td>&nbsp;</td>
  <td><?=htmlise($election['advertise_candidates-status'])?></td>
</tr>
<tr>
  <td><a href="#voting">Voting</a></td>
  <td><?=htmlise($election['start_voting'])?></td>
  <td><?=htmlise($election['close_voting'])?></td>
  <td><?php
  if($election['voting']=='closed') {
    if(time() < strtotime($election['start_voting']))
      echo 'not yet open';
    else
      echo 'closed';
  } else {
    echo htmlise($election['voting']);
  }
?>
  </td>
</tr>
<tr>
  <td><a href="?page=election-result&id=<?=urlencode($election['id'])?>">Results</a></td>
  <td><?=htmlise($election['show_results'])?></td>
  <td>&nbsp;</td>
  <td><?=htmlise($election['results'])?></td>
</tr>
</tbody>
</table>

<h2><a id="positions">Positions</a></h2>
<p>The following positions are being voted on:</p>
<dl>
<?php
  foreach($election['position'] as $num => $pos) {
    echo '<dt>'.htmlise($pos['name']).' ('.htmlise($pos['num']).')</dt>';
    echo '<dd>'.htmlise($pos['desc']).'</dd>';
  }
?>
</dl>

<h2><a id="nominations">Nominations</a></h2>
<?php
if($election['nominations-status']=='open') {
?>
<p>You can currently <a href="?page=election-nominate&id=<?=htmlise($_GET['id'])?>">nominate</a> somebody for a position in this election.</p>
<?php
    }// nominations==open
?>
<p>There must be at least <?=htmlise($election['num_req_nominations'])?> <?=($election['num_req_nominations']<2)?'nomination':'nominations'?> for somebody before they can become a candidate. The following nominations exist:</p>
<?php
foreach($election['position'] as $num => $pos) {
  echo '<h3>'.htmlise($pos['name']).'</h3><ul>';
  $for = $dbh->getAll("select DISTINCT for_member_id from election_candidate_nomination where election_position_id = $num",array(),DB_FETCHMODE_ASSOC);
  if(!count($for))
    echo '<li>There are no current nominations for this position.</li>';
  foreach($for as $f) {
    $f_m = get_member($f['for_member_id']);
    echo "<li>".htmlise($f_m->first_name.' '.$f_m->last_name);
    echo ' (<a href="mailto:'.htmlise($f_m->email).'">'
      .htmlise($f_m->email).'</a>)';
    $nom = $dbh->getAll("select from_member_id,reason from election_candidate_nomination where election_position_id =$num and for_member_id=".$f_m->id,array(),DB_FETCHMODE_ASSOC);
    echo ' was nominated by:<ul>';
    foreach($nom as $n) {

      $n_m = get_member($n['from_member_id']);
      echo '<li><b>';
      echo htmlise($n_m->first_name.' '.$n_m->last_name);
      echo ' (<a href="mailto:'.htmlise($n_m->email).'">'
	.htmlise($n_m->email).'</a>)';
      echo '</b><br/>';
      echo htmlise($n['reason']).'</li>';
    }
    echo '</ul>';
    echo '</li>';
  }
  echo '</ul>';
}
?>

<h2><a id="candidates">Candidates</a></h2>
<?php
if ($election['advertise_candidates-status']!='visible') {
  echo '<p>Candidates are not yet visible.</p>';
} else {
  foreach($election['candidates'] as $c) {
    if($last_election_position_id != $c['election_position_id']) {
      echo (!isset($last_election_position_id))?'':'</ul>';
      echo '<h3>'
	.htmlise($election
		 ['position']
		 [$c['election_position_id']]
		 ['name'])
	.'</h3>'
	.'<ul>';
    }
    $last_election_position_id=$c['election_position_id'];
    $m = get_member($c['member_id']);
    echo '<li>'.htmlise($m->first_name.' '.$m->last_name).' '
      .'(<a href="mailto:'.htmlise($m->email).'">'.htmlise($m->email)
      .'</a>)'
      .'<br/>'.htmlise($c['spiel']).'</li>';
  }
  echo '</ul>';
}
?>

<h2><a id="voting">Voting</a></h2>
<p>Votes are cast by filling out a web form. Voting is preferential, but you do not have to give preferences to all candidates. You can only vote for candidates (see above list). After you have voted, an email is sent to you with the details of your vote.</p>

<?php
if($election['voting']=='open') {
  // Voting is open - offer to let the user vote
  echo '<p>Voting is currently open. You may <a href="?page=election-vote&id='
  .urlencode($_GET['id']).'">Vote Now!</a>.</p>';
} else {
  echo '<p>Voting is currently closed. You may not vote at this time.</p>';
}
?>
