<?php
/**
 * Signup Logic
 *
 *
 * @author (C) 2003-2006 Stewart Smith
 * Distributed under the GPL.
 */

$title = $org->name." Membership Signup";
headers(array('title'=>$title,'menu'=>1));

$member= NULL;

include 'forms/member.inc';

echo '<div class="stdform">';

$errors = validate($form_editmember, $HTTP_POST_VARS);

if(!$errors && strtolower($_SERVER['REQUEST_METHOD']) == 'post'
   && $_POST['signup']=='Apply for Membership') {
  $dbh->query("begin");
  $id = $dbh->nextId('public.members_id_seq');

  if($_POST['sex']=='Male')
    $sexval = 'M';
  else if ($_POST['Sex']=='Female')
    $sexval = 'F';
  else
    $sexval = ' ';

  sql_insert('members',array('first_name'  => $_POST['first_name'],
			     'middle_name' => $_POST['middle_name'],
			     'last_name'   => $_POST['last_name'],
			     'dob'         => $_POST['dob'],
			     'sex'         => $sexval,
			     'address1'    => $_POST['address1'],
			     'address2'    => $_POST['address2'],
			     'suburb'      => $_POST['suburb'],
			     'postcode'    => $_POST['postcode'],
			     'state'       => $_POST['state'],
			     'country'     => $_POST['country'],
			     'email'       => $_POST['email'],
			     'phone_home'  => $_POST['phone_home'],
			     'phone_mobile'=> $_POST['phone_mobile']));

  /* We don't need to quote anything
     in this query as it's all valid anyway (from the DB or subselect).

     This basically stores that the member (created above) is applying for
     membership to our organisation (as set in the config). The 'Pending'
     type of membership lasts for a year. Although it could be different...
  */
  $sql = "select LAST_INSERT_ID() as seq";
  $result = $dbh->query($sql);
  if(DB::isError($result)) {
        my_syslog(LOG_INFO,$result->getMessage());
  }
  $row = $result->fetchrow(DB_FETCHMODE_OBJECT);
  $id = $row->seq;
  my_syslog(LOG_DEBUG,"member id seq: $id");

  $sql = 'insert into org_members (org_id,member_id,member_type_id,start_date,expiry) values ('.$config['org_id'].",$id,(select id from member_types where type='Applied'),now(),now()+'1year')";
  my_syslog(LOG_DEBUG,$sql);
  $result = $dbh->query($sql);
  if (DB::isError($result)) {
    my_syslog(LOG_INFO,$result->getMessage());
  }

  $messagevars= array('ORG_NAME'=>$org->name,
		      'ORG_URL'=>$org->website,
		      'MEMBERSHIP_ADMIN'=>$config['membership-admin'],
		      'DATE'=>'Now',
		      'MEMBER_EMAIL'=>$_POST['email'],
		      'MEMBER_DETAILS'=>
		       "First Name: ".$_POST['first_name']."\n".
		       "Middle Name/Initial: ".$_POST['middle_name']."\n".
		       "Surname: ".$_POST['last_name']."\n".
		       "Sex: ".$_POST['Sex']."\r\n".
		       "Address 1: ".$_POST['address1']."\n".
		       "Address 2: ".$_POST['address2']."\n".
		       "Suburb: ".$_POST['suburb']."\n".
		       "Postcode: ".$_POST['postcode']."\n".
		       "State: ".$_POST['state']."\n".
		       "Country: ".$_POST['country']."\n".
		       "Email: ".$_POST['email']."\n".
		       "Home Phone: ".$_POST['phone_home']."\n".
		       "Mobile Phone: ".$_POST['phone_mobile']."\n\n",
		      'ACTION_URL'=>
		        $config['baseurl'].'?page=confirm_membership&id='.$id
		      );

  site_message('signup/application-request-for-confirm', $messagevars);

  $dbh->query("commit");

  print '<p>You submitted the following information:</p>'.
    '<ul>'.
    '<li><b>First Name: </b>'.$_POST['first_name'].'</li>'.
    '<li><b>Middle Name/Initial: </b>'.$_POST['middle_name'].'</li>'.
    '<li><b>Surname: </b>'.$_POST['last_name'].'</li>'.
    '<li><b>Sex: </b>'.$_POST['Sex'].'</li>'.
    '<li><b>Address 1: </b>'.$_POST['address1'].'</li>'.
    '<li><b>Address 2: </b>'.$_POST['address2'].'</li>'.
    '<li><b>Suburb: </b>'.$_POST['suburb'].'</li>'.
    '<li><b>Postcode: </b>'.$_POST['postcode'].'</li>'.
    '<li><b>State: </b>'.$_POST['state'].'</li>'.
    '<li><b>Country: </b>'.$_POST['country'].'</li>'.
    '<li><b>Email Address: </b>'.$_POST['email'].'</li>'.
    '<li><b>Home Phone: </b>'.$_POST['phone_home'].'</li>'.
    '<li><b>Mobile Phone: </b>'.$_POST['phone_mobile'].'</li>'.
    '</ul>';

  print '<p>You will shortly receive an email confirming your application for membership. Your membership will become active once confirmed by the secretary and you shall receive email notification of this.</p>';

} else {
  include $config['basedir'].'/site-look/signup/responsibilities.inc';

  echo '<h2>Details</h2>';
  print $errors;
  output_form($form_editmember,"signup","Apply for Membership","post","");
}
echo '</div>';


?>
